Port_Register equ 0c8h
Port_Out equ Port_Register+1

Psg_Tone_A equ 0
Psg_Tone_B equ 2
Psg_Tone_C equ 4
Psg_Noise equ 6
Psg_Mixer equ 7
Psg_Volume_A equ 8
Psg_Volume_B equ 9
Psg_Volume_C equ 10
Psg_EnvTime equ 11
Psg_EnvType equ 13
Psg_Input1 equ 14
Psg_Input2 equ 15

Opn_OnOff equ 28h
Opn_Part equ 30h

MaxVol equ 63

tempo equ 220 / 2

PsgCount equ 3
OpnCount equ 3
AllCount equ PsgCount+OpnCount
Channel_Ptr equ 0
Channel_Start equ Channel_Ptr+2
Channel_Len equ Channel_Start+2
Channel_Vol equ Channel_Len+1
unitSize equ Channel_Vol+1

    dseg
Channels defs unitSize*AllCount
time: defw 0


cseg

WaitPort:
    push af
        ld a,6
        do
            dec a
        while nz | wend
        do
            in a,(Port_Register)
            and 80h
        while nz | wend
    pop af
ret


; BassTone:
;     defb 58,48,48,48
;     defb 36,18,45,0
;     defb 31,95,31,95
;     defb 18,10,14,10
;     defb 0,4,4,3
;     defb 38,38,38,38
;     defb 58
; BassTone:
;     defb 96,96,96,96
;     defb 23,23,63,0
;     defb 158,156,152,156
;     defb 14,4,10,5
;     defb 8,9,9,9
;     defb 182,198,198,198
;     defb 48
BassTone:
    defb 96,96,102,97
    defb 33,40,20,0
    defb 31,31,148,31
    defb 15,5,16,13
    defb 7,6,6,7
    defb 40,23,71,87
    defb 58
PianoTone:
    defb 15,82,50,2
    defb 65,27,0,0
    defb 94,94,94,158
    defb 15,8,7,8
    defb 5,5,5,5
    defb 143,143,143,143
    defb 60
SnareTone:
    defb 15,0,0,0
    defb 14,19,17,0
    defb 31,31,31,31
    defb 0,24,15,19
    defb 0,0,17,16
    defb 8,184,44,44
    defb 60

Tones:
    defw BassTone,PianoTone,SnareTone

SetTone:
    ld b,24
    do
        call WaitPort
        ld a,c
        out (Port_Register),a
        ex (sp),hl | ex (sp),hl
        ld a,(hl) | inc hl
        out (Port_Out),a
        inc c | inc c | inc c | inc c
    dwnz
    ld a,c | add a,20h
    out (Port_Register),a
    ex (sp),hl | ex (sp),hl
    ld a,(hl) | inc hl
    out (Port_Out),a
ret

InitSound_: public InitSound_
    ld hl,Channels
    xor a
    ld b,AllCount*unitSize
    do
        ld (hl),a
        inc hl
    dwnz
    ld hl,0
    ld (time),hl

    ld a,Psg_Mixer
    out (Port_Register),a
    ld a,38h
    out (Port_Out),a

    ld bc,OpnCount * 256
    do
        call WaitPort
        ld a,Opn_OnOff
        out (Port_Register),a
        ex (sp),hl | ex (sp),hl
        ld a,c
        out (Port_Out),a
        inc c
    dwnz
ret

SoundHandler: public SoundHandler
    push hl | push de
        ld hl,(time)
        ld de,-tempo
        add hl,de
        if nc
            push hl | push bc | push ix
                ld ix,Channels
                ld bc,PsgCount * 100h ; b = count; c = register
                do
                    ld l,(ix+Channel_Ptr)
                    ld h,(ix+Channel_Ptr+1)
                    ld a,l
                    or h
                    if nz
                        dec (ix+Channel_Len)
                        if z
                            continue:
                            ld a,(hl)
                            or a
                            if z
                                ; end
                                ld (ix+Channel_Ptr),a
                                ld (ix+Channel_Ptr+1),a
                                ld a,c
                                add a,Psg_Volume_A
                                out (Port_Register),a
                                xor a
                                out (Port_Out),a
                                jr next
                            endif
                            inc a
                            if z 
                                ; repeat
                                ld l,(ix+Channel_Start)
                                ld h,(ix+Channel_Start+1)
                                jr continue
                            endif
                            dec a
                            ld (ix+Channel_Len),a
                            inc hl
                            ld a,(hl)
                            inc hl
                            ld (ix+Channel_Ptr),l
                            ld (ix+Channel_Ptr+1),h
                            or a
                            if nz
                                dec a
                                add a,a
                                ld e,a
                                ld d,0
                                ld hl,cycles
                                add hl,de
                                ld a,c
                                add a,a
                                ld e,a
                                out (Port_Register),a
                                ld a,(hl)
                                inc hl
                                out (Port_Out),a
                                ld a,e
                                inc a
                                out (Port_Register),a
                                ld a,(hl)
                                out (Port_Out),a
                                ld (ix+Channel_Vol),MaxVol
                            else
                                ld (ix+Channel_Vol),0
                            endif
                            EndWriteCycle:
                        endif
                        ld a,c
                        add a,Psg_Volume_A
                        out (Port_Register),a
                        ld a,(ix+Channel_Vol)
                        srl a | srl a
                        out (Port_Out),a
                        ld a,(ix+Channel_Vol)
                        or a
                        if nz
                            dec a
                            ld (ix+Channel_Vol),a
                        endif
                    endif
                    next:
                    inc c
                    ld de,unitSize
                    add ix,de
                dwnz
                ld bc,300h ; b = count; c = channel
                do
                    ld l,(ix+Channel_Ptr)
                    ld h,(ix+Channel_Ptr+1)
                    ld a,l
                    or h
                    if nz
                        dec (ix+Channel_Len)
                        if z
                            ld a,(ix+Channel_Vol)
                            or a
                            if nz
                                call WaitPort
                                ld a,Opn_OnOff
                                out (Port_Register),a
                                ex (sp),hl | ex (sp),hl
                                ld a,c
                                out (Port_Out),a
                                ld (ix+Channel_Vol),0
                            endif
                            continue2:
                            ld a,(hl)
                            or a
                            if z
                                ; end
                                ld (ix+Channel_Ptr),a
                                ld (ix+Channel_Ptr+1),a
                                jr next2
                            endif
                            inc a
                            if z 
                                ; repeat
                                ld l,(ix+Channel_Start)
                                ld h,(ix+Channel_Start+1)
                                jr continue2
                            endif
                            dec a
                            ld (ix+Channel_Len),a
                            inc hl
                            ld a,(hl)
                            inc hl
                            ld (ix+Channel_Ptr),l
                            ld (ix+Channel_Ptr+1),h
                            or a
                            if nz
                                dec a
                                add a,a
                                ld e,a
                                ld d,0
                                ld hl,OpnScales
                                add hl,de
                                ld a,c
                                add a,0a4h
                                call WaitPort
                                out (Port_Register),a
                                ex (sp),hl | ex (sp),hl
                                ld a,(hl)
                                inc hl
                                out (Port_Out),a
                                call WaitPort
                                ld a,c
                                add a,0a0h
                                out (Port_Register),a
                                ex (sp),hl | ex (sp),hl
                                ld a,(hl)
                                out (Port_Out),a

                                push bc
                                    ld l,c
                                        
                                    ld a,c
                                    add a,Opn_Part
                                    ld c,a
                                    sla l
                                    ld h,0
                                    ld de,Tones
                                    add hl,de
                                    ld a,(hl) | inc hl
                                    ld h,(hl)
                                    ld l,a
                                    call SetTone
                                pop bc

                                call WaitPort
                                ld a,Opn_OnOff
                                out (Port_Register),a
                                ex (sp),hl | ex (sp),hl
                                ld a,c
                                or 0f0h
                                out (Port_Out),a
                                ld (ix+Channel_Vol),0ffh
                            endif
                        endif
                    endif
                    next2:
                    inc c
                    ld de,unitSize
                    add ix,de
                dwnz
            pop ix | pop bc | pop hl
            ld de,600/2
            add hl,de
        endif
        ld (time),hl
    pop de | pop hl
ret

Melody0:
    di
    ld (Channels+Channel_Ptr),hl
    ld a,1
    ld (Channels+Channel_Len),a
    ld a,Psg_Volume_A
    out (Port_Register),a
    xor a
    out (Port_Out),a
    ei
ret


MelodyWait0:
    call Melody0
    do
        ld hl,(Channels+Channel_Ptr)
        ld a,l
        or h
    while nz | wend
ret 

Melody4:
    di
    ld (Channels+unitSize*4+Channel_Ptr),hl
    ld a,1
    ld (Channels+unitSize*4+Channel_Len),a
    ei
ret


MelodyWait4:
    call Melody4
    do
        ld hl,(Channels+unitSize*4+Channel_Ptr)
        ld a,l
        or h
    while nz | wend
ret 


N8 equ 6
N8P equ N8*3/2
N4 equ N8*2
N4P equ N4*3/2
N2 equ N4*2
N2P equ N2*3/2
N1 equ N2*2


get_notes:
    defb 1,A4, 0
Sound_Beep_: public Sound_Beep_
Sound_Get_: public Sound_Get_
    push af | push hl
        ld hl,get_notes
        call MelodyWait0
    pop hl | pop af
ret


loose_notes:
    defb 1,A3, 0
Sound_Loose_: public Sound_Loose_
    push af | push hl
        ld hl,loose_notes
        call MelodyWait0
    pop hl | pop af
ret

hit_notes:
    defb 1,F4, 1,G4, 1,A4, 1,B4, 1,C5, 1,D5, 1,E5, 1,F5
    defb 0 
Sound_Hit_: public Sound_Hit_
    push af | push hl
        ld hl,hit_notes
        call MelodyWait0
    pop hl | pop af
ret

start_notes: defb 3,C4, 3,G4, 3,E4, 3,G4, 12,C5, 0
Sound_Start_: public Sound_Start_
    push af | push hl
        ld hl,start_notes
        call MelodyWait4
    pop hl | pop af
ret

clear_notes: defb 3,C4, 3,E4, 3,G4, 3,D4, 3,F4, 3,A4, 3,E4, 3,G4, 3,B4, 9,C5,0
Sound_Clear_: public Sound_Clear_
    push af | push hl
        ld hl,clear_notes
        call MelodyWait4
    pop hl | pop af
ret

over_notes: defb 3,C5, 3,G4, 3,E4, 3,C5,  3,B4, 3,G4, 3,E4, 3,B4,  6,A4, 6,B4,  12,C5, 0
Sound_GameOver_: public Sound_GameOver_
    push af | push hl
        ld hl,over_notes
        call MelodyWait4
    pop hl | pop af
ret


BGM_B: 
    defb 3,D4, 3,F4, 3,G4
    defb 3,A4, 3,A4, 3,A4, 3,A4, 3,A4, 3,A4, 3,A4, 3,A4
    defb 3,G4, 3,G4, 3,G4, 3,G4, 3,G4, 3,G4, 3,A4, 3,G4
    defb 12,F4, 12,G4, 18,A4
    defb 3,D4, 3,F4, 3,G4
    defb 3,A4, 3,A4, 3,A4, 3,A4, 3,A4, 3,A4, 3,A4, 3,A4
    defb 3,G4, 3,G4, 3,G4, 3,G4, 3,G4, 3,G4, 3,A4, 3,G4
    defb 12,F4, 12,G4, 18,F4
    defb 0ffh
BGM_C: 
    defb 9,0
    defb 9,F3, 9,F3, 6,F3
    defb 9,C4, 9,C4, 6,C4
    defb 12,F3, 12,G3, 18,A3, 9,0
    defb 9,A3, 9,A3, 6,A3
    defb 9,G3, 9,G3, 6,G3
    defb 12,F3, 12,C4, 18,F3
    defb 0ffh
BGM_D: 
    defb 3,A4, 3,A4, 3,A4
    defb 6,0, 6,A4, 6,0, 6,A4  
    defb 6,0, 6,A4, 6,0, 6,A4
    defb 6,0, 6,A4, 6,0, 6,A4, 6,0, 3,A4, 3,A4, 3,0, 3,A4
    defb 0ffh

StartBGM_: public StartBGM_
    push af | push hl
        di
        ld a,1
        ld hl,BGM_B
        ld (Channels+unitSize*4+Channel_Start),hl
        ld (Channels+unitSize*4+Channel_Ptr),hl
        ld (Channels+unitSize*4+Channel_Len),a
        ld hl,BGM_C
        ld (Channels+unitSize*3+Channel_Start),hl
        ld (Channels+unitSize*3+Channel_Ptr),hl
        ld (Channels+unitSize*3+Channel_Len),a
        ld hl,BGM_D
        ld (Channels+unitSize*5+Channel_Start),hl
        ld (Channels+unitSize*5+Channel_Ptr),hl
        ld (Channels+unitSize*5+Channel_Len),a
        ei
    pop hl | pop af
ret

StopBGM_: public StopBGM_
    push af | push hl | push bc
        di
            ld hl,0
            ld (Channels+unitSize*4+Channel_Ptr),hl
            ld (Channels+unitSize*3+Channel_Ptr),hl
            ld (Channels+unitSize*5+Channel_Ptr),hl
            ld a,1
            ld (Channels+unitSize*4+Channel_Len),a
            ld (Channels+unitSize*3+Channel_Len),a
            ld (Channels+unitSize*5+Channel_Len),a
            
            ld bc,3*256 or Psg_Volume_A
            do
                call WaitPort
                ld a,c
                out (Port_Register),a
                xor a
                out (Port_Out),a
                inc c
            dwnz
            ld bc,300h
            do
                call WaitPort
                ld a,Opn_OnOff
                out (Port_Register),a
                ex (sp),hl | ex (sp),hl
                ld a,c
                out (Port_Out),a
                inc c
            dwnz
        ei
    pop bc | pop hl | pop af
ret


E3 equ 1
F3 equ 2
F3S equ 3
G3 equ 4
G3S equ 5
A3 equ 6
A3S equ 7
B3 equ 8
C4 equ 9
C4S equ 10
D4 equ 11
D4S equ 12
E4 equ 13
F4 equ 14
F4S equ 15
G4 equ 16
G4S equ 17
A4 equ 18
A4S equ 19
B4 equ 20
C5 equ 21
C5S equ 22
D5 equ 23
D5S equ 24
E5 equ 25
F5 equ 26

cycles:
defw 758 ;E3
defw 716 ;F3
defw 676 ;F#3
defw 638 ;G3
defw 602 ;G#3
defw 568 ;A3
defw 536 ;A#3
defw 506 ;B3
defw 478 ;C4
defw 451 ;C#4
defw 426 ;D4
defw 402 ;D#4
defw 379 ;E4
defw 358 ;F4
defw 338 ;F#4
defw 319 ;G4
defw 301 ;G#4
defw 284 ;A4
defw 268 ;A#4
defw 253 ;B4
defw 239 ;C5
defw 225 ;C#5
defw 213 ;D5
defw 201 ;D#5
defw 190 ;E5
defw 179 ;F5

OpnScales:
defb 27,10 ;E3
defb 27,56 ;F3
defb 27,105 ;F#3
defb 27,157 ;G3
defb 27,212 ;G#3
defb 28,14 ;A3
defb 28,76 ;A#3
defb 28,141 ;B3
defb 34,105 ;C4
defb 34,142 ;C#4
defb 34,181 ;D4
defb 34,222 ;D#4
defb 35,10 ;E4
defb 35,56 ;F4
defb 35,105 ;F#4
defb 35,157 ;G4
defb 35,212 ;G#4
defb 36,14 ;A4
defb 36,76 ;A#4
defb 36,141 ;B4
defb 42,105 ;C5
defb 42,142 ;C#5
defb 42,181 ;D5
defb 42,222 ;D#5
defb 43,10 ;E5
defb 43,56 ;F5
defb 43,105 ;F#5
defb 43,157 ;G5
