include "MemMap.inc"
include "Vram.inc"
include "VVram.inc"

ext FillMemory_
ext VVram_

GVram equ 0c000h

; void ClearScreen();
cseg
ClearScreen_: public ClearScreen_
    push af | push hl | push de | push bc
        ld a,05h | out (GraphPort),a
        ld a,8fh | out (GraphPort+1),a

        ld hl,Vram
        ld de,VramWidth*VramHeight
        ld c,0
        call FillMemory_
        ld hl,Vram+1000h
        call FillMemory_
        ld hl,Vram+800h
        ld c,08h
        call FillMemory_

        ld a,10h or 80h | out (GraphPort),a
        xor a | out (GraphPort),a | out (GraphPort),a | out (GraphPort),a
    pop bc | pop de | pop hl | pop af
ret


; ; word word VramAddress(byte x, byte y);
; cseg
; VramAddress_: public VramAddress_
;     push af | push bc
;         ld c,a
;         ld a,e
;         add a,a ;*2
;         add a,a ;*4
;         add a,e ;*5
;         ld l,a
;         ld h,0
;         add hl,hl ;*10
;         add hl,hl ;*20
;         add hl,hl ;*40
;         ld b,0
;         add hl,bc
;         ld bc,Vram
;         add hl,bc
;     pop bc | pop af
; ret


cseg
PCGAddressHL:
    ld l,a
    ld h,0
    add hl,hl ;*2
    add hl,hl ;*4
    add hl,hl ;*8
    ld de,PCGAddress+800h
    add hl,de
ret


; void SetPcgMono(byte code, ptr<byte> pPattern, byte color, byte count);
dseg
SetPcgMono_@Param3: public SetPcgMono_@Param3
    defb 0
cseg
SetPcgMono_: public SetPcgMono_
    push af | push hl | push de | push bc
        exx
            call PCGAddressHL
        exx
        ld a,(SetPcgMono_@Param3)
        ld b,a
        do
            push bc
                ld b,3
                do
                    push de
                        ld h,CharHeight
                        do
                            ld a,(de) | inc de
                            ld l,0
                            bit 0,c
                            if nz
                                or l | ld l,a
                            endif
                            bit 4,c
                            if nz
                                cpl
                                or l | ld l,a
                            endif
                            ld a,l
                            exx
                                ld (hl),a | inc hl
                            exx
                            dec h
                        while nz | wend
                        exx
                            ld de,800h-CharHeight
                            add hl,de
                        exx
                        srl c
                    pop de
                dwnz
                ex de,hl
                    ld de,CharHeight
                    add hl,de
                ex de,hl
                exx
                    ld de,-800h*3+CharHeight
                    add hl,de
                exx
            pop bc
        dwnz
    pop bc | pop de | pop hl | pop af
ret


; void SetPcgColor(byte code, ptr<byte> pPattern, byte count);
cseg
SetPcgColor_: public SetPcgColor_
    push af | push hl | push de | push bc
        exx
            call PCGAddressHL
        exx
        ld b,c
        do
            push bc
                ld b,3
                do
                    ld h,CharHeight
                    do
                        ld a,(de) | inc de
                        exx
                            ld (hl),a | inc hl
                        exx
                        dec h
                    while nz | wend
                    exx
                        ld de,800h-CharHeight
                        add hl,de
                    exx
                dwnz
                exx
                    ld de,-800h*3+CharHeight
                    add hl,de
                exx
            pop bc
        dwnz
    pop bc | pop de | pop hl | pop af
ret


; word Put(word vram, byte c);
cseg
Put_: public Put_
    ld (hl),e | inc hl
ret


; void VVramToVram();
cseg
VVramToVram_: public VVramToVram_
    push af | push hl | push de | push bc
        ld de,VVram_
        ld hl,Vram
        ld c,VVramHeight
        do
            ld b,VVramWidth
            do
                ld a,(de) | inc de
                ld (hl),a | inc hl
            dwnz
            push bc
                ld bc,VramRowSize-VVramWidth*VramStep
                add hl,bc
            pop bc
            dec c
        while nz | wend
    pop bc | pop de | pop hl | pop af
ret
